- UID
- 658062
- 积分
- 2147
- 精华
- 贡献
-
- 威望
-
- 活跃度
-
- D豆
-
- 在线时间
- 小时
- 注册时间
- 2008-10-22
- 最后登录
- 1970-1-1
|
马上注册,结交更多好友,享用更多功能,让你轻松玩转社区。
您需要 登录 才可以下载或查看,没有账号?立即注册
×
[CommandMethod("ptsRead")]
public void testReadCSV()
{ // file name contains separated text
string filePath = @"C:\Test\points.txt";
if (!File.Exists(filePath))
{
MessageBox.Show("File does not exist");
return;
}
// put appropriate delimiter here
string sep = ";";
Point3dCollection pts = new Point3dCollection();
using (System.IO.StreamReader reader = new System.IO.StreamReader(filePath))
{
while (!reader.EndOfStream)
{
// Call reader.ReadLine() appropriately
string textLine = reader.ReadLine();
Autodesk.AutoCAD.ApplicationServices.Application.DocumentManager.MdiActiveDocument.Editor.WriteMessage("\n{0}", textLine);
string[] tmp = textLine.Split(new string[] { sep }, StringSplitOptions.RemoveEmptyEntries);
if (tmp.Length != 0)
{
Point3d pt = new Point3d(Convert.ToDouble(tmp[0]), Convert.ToDouble(tmp[1]), Convert.ToDouble(tmp[2]));
pts.Add(pt);
}
}
}
if (pts == null)
{
MessageBox.Show("Cant parse this file");
return;
}
Document doc = Autodesk.AutoCAD.ApplicationServices.Application.DocumentManager.MdiActiveDocument;
Database db = doc.Database;
Editor ed = doc.Editor;
Autodesk.AutoCAD.ApplicationServices.Application.SetSystemVariable("pdmode", 34);
Autodesk.AutoCAD.ApplicationServices.Application.SetSystemVariable("pdsize", 2.0);
using (Transaction tr = db.TransactionManager.StartTransaction())
{
BlockTableRecord btr = tr.GetObject(db.CurrentSpaceId, OpenMode.ForWrite) as BlockTableRecord;
foreach (Point3d pnt in pts)
{
DBPoint pt = new DBPoint(pnt);
pt.SetDatabaseDefaults();
pt.ColorIndex = 1;// <-- set any color of point
btr.AppendEntity(pt);
DBText txt = new DBText();
tr.AddNewlyCreatedDBObject(pt, true);
txt.SetDatabaseDefaults();
txt.Position = pt.Position;
txt.TextString = txt.Position.ToString();//<-- add any textstring to suit
txt.Justify = AttachmentPoint.BaseLeft;
// txt.AlignmentPoint = pt.Position;
txt.AdjustAlignment(db);
btr.AppendEntity(txt);
tr.AddNewlyCreatedDBObject(txt, true);
}
tr.Commit();
}
} |
|